#include <stdio.h>
#include <unistd.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <linux/types.h>
#include <linux/videodev.h>

void main()
{
	int fd, i, j;
	unsigned char* addr;
	struct video_mmap vidmmap;
	struct	video_channel vidchan;
	char *p;
	char line[1024];

	fd = open("/dev/video0",O_RDONLY);
	if (fd<0) {
		perror("open");
		exit(1);
	}
	addr = mmap(0,65536,PROT_READ,MAP_PRIVATE,fd,0L);
	if (addr == (void*)-1) {
		perror("mmap");
		exit(1);
	}

	/* setup channel */
	vidchan.channel = 0;
	if (ioctl(fd,VIDIOCSCHAN,&vidchan) < 0) {
		perror("ioctl(VIDIOCSCHAN)");
		exit(1);
	}

	vidmmap.frame = 0;
	vidmmap.width = 100;
	vidmmap.height = 100;
	vidmmap.format = 0;
		if (ioctl(fd,VIDIOCMCAPTURE,&vidmmap) < 0) {
			perror("ioctl(VIDIOMCAPTURE)");
			exit(1);
		}
	for (j=0; j<10; j++) {	
		fputs("\033[H",stdout);
		for (i=0; i<600; i++) {
			if ((i % 24) == 0) {
				if (i) printf("%s\n",line);
				p = line;
				p += sprintf(p, "%04x: ", i*4);
			}
			p += sprintf(p, "%02x ",addr[i*4]);
		}
		sleep(1);
	}

	if (munmap(0,65536) < 0) {
		perror("munmap");
		exit(1);
	}
	close(fd);
}
